


## ExcelからPythonを利用してデータを処理するデモシステム一式

__概要__
このシステムは，ExcelからPythonを実行して結果を取得するデモシステムです．Pythonの実行環境を持たない任意の利用者は，開発者のあなたが作成したPythonのプログラムにエクセルからアクセスすることができるようになります．
これにより
- 利用者ごとにPythonの環境をセットアップする手間を削減
- Excelという使い慣れたインターフェースとPythonを連携することができるように

なります．

__システム構成の概要__

FlaskというWebを介してプログラムを実行するPythonライブラリを利用しています．
実行するとWebサーバが立ち上がるので，エクセルのマクロからそのURLにアクセスすることでPythonのプログラムを実行することができます．利用する人にPythonの実行環境は必要ありません．


（図）


__使用例__

下記のようにwebapiというフォルダとexcelというフォルダがあります．

（図）

webapiフォルダにPythonプログラムが入っていますので，この中のmain.pyを実行することでWebサーバを立ち上げることができます．

```
python main.py
```

Flaskが立ち上がり，Webを介してmain.pyのプログラムを実行できるようになります．これで準備は完了です．excelからWebを介してプログラムを実行します．共有したいPythonのプログラムをmain.pyのなかに入れる必要があります．



- 認証機能をつけていること: Flask


## 概要

#### このソフトウェアについて

__このソフトウェアがあれば効率的にバックエンドシステムを構築できます__
このソフトウェアは認証機能を付与したFlaskのファイルです．Flaskは軽量のWebフレームワークであり，フロントエンドを含まないバックエンドシステムの構築場面で最適なフレームワークです．Flaskを利用したバックエンドシステムを構築したい場合，こちらのソフトウェアを雛形として利用することで作業を劇的に効率化することができます．
サンプルをこのFlaskファイルは，実際のデプロイ時に求められる認証機能をつけたバックエンド構築における



### できるようになること

Webを介して任意のPythonプログラムを実行できるようになりますので，任意のプログラムからPythonで行った処理を呼び出すことができるようになります．

これは一般的なWebページはもちろん，Excelやコマンドラインを含みます．


APIとは
スクリプトを実行するとWebサーバが立ち上がります．そこにアクセスすることでWebを介してGPT-3を利用することができます．プログラムはAWS，GCP，Herokuなどにデプロイすることが可能です．

![image.jpg](image.jpg)


## 使用例

スクリプトをローカルで実行すると，http://127.0.0.1:5001 のWebサーバが立ち上がります．チャットを行うためのエンドポイントが/chatで提供されますので，そちらにアクセスすることでGPT-3のチャット機能を使うことができます．

```bash
curl -X GET 127.0.0.1:5100/answer?text=GPT-3とはなんですか？
% GPT-3とはOpenAIが開発した言語モデルです．
```
通信形態や引数について下記の欄をご参照ください．

### エンドポイント

chat, answer, generationのエンドポイントがあります．
各エンドポイントへの

##### Answer

Pythonとはなんですか？人間とはどのような動物ですか？といった事実に関する回答を提供するエンドポイントです．

```
Get：   /answer
```

パラメータ(body)
:   名前:text
:   役割: GPT-3に与える質問文．
:   型:文字列型
:   必要性:必須引数

パラメータ(header)
:   名前:text
:   役割: GPT-3に与える質問文．
:   型:文字列型
:   必要性:必須引数



レスポンス


### セットアップ

pipコマンドでライブラリをインストールします．
```
pip install　openAI
pip install　flask
```

Webサーバを起動します
```
python main.py
```


## 備考

- ソースコードの販売となるため環境構築などは対応致しかねます．ご自身で環境構築できる方向けに販売しております．
- GPT-3のAPIキーの売買，リースは禁止されているためお手元にご自身のAPIキーをご用意いただく必要がございます．
- 返答の精度はGPT-3に依存するため，当方にて所望の性能を保証することはできかねます．