# coding: utf-8
import os
import io
import time
import string
import random
from datetime import datetime, date
from flask import Flask, render_template, request, redirect, url_for, send_from_directory,send_file
from flask_cors import CORS
import inspect
import pandas as pd
import six
from google.cloud import translate_v2 as translate
import openai
import os
import six
import sys
import yaml
with open('./secret.yaml', 'r') as yml:
    config = yaml.load(yml)
OPENAI_API_KEY = config['env_variables']['OPENAI_API_KEY']
os.environ['GOOGLE_APPLICATION_CREDENTIALS'] = './np-sys-210404-7b5e662eae1d.json'


app = Flask(__name__)
CORS(app)
app.config['JSON_AS_ASCII'] = False

IS_NO_AUTHORIZATION = False

def json_serial(obj):
    if isinstance(obj, (datetime, date)):
        return obj.isofrmat()
    raise TypeError ("Type %s not serializable"%(type(obj)))

def _decorator_of_auth_verification(func):
    def wrapper(*args, **kwargs):
        if IS_NO_AUTHORIZATION:
            return func()
        id = request.headers.get(key='Id')
        token = request.headers.get(key='Authorization')
        print('id:',id,'token:',token)
        if (id is None) or (token is None):
            return {
                'statusCode':203
            }
        else:
            if (id == 'id_firebasehosting')&(token == 'token_hl7gsayusausfdl'):
                return func()
            else:
                return {
                    'statusCode':203
                }
    return wrapper

def _parse_query(key):
    if request.method == 'GET':
        return request.args.get(key=key)
    elif request.method == 'POST':
        return request.form.get(key=key)

def _translate_text(target, text):
    translate_client = translate.Client()

    if isinstance(text, six.binary_type):
        text = text.decode("utf-8")
    result = translate_client.translate(text, target_language=target)
    print(u"Text: {}".format(result["input"]))
    print(u"Translation: {}".format(result["translatedText"]))
    print(u"Detected source language: {}".format(result["detectedSourceLanguage"]))
    return result["translatedText"]

@app.route('/', endpoint='index', methods=["GET"])
@_decorator_of_auth_verification
def index():
    return 'index'
    openai.api_key = OPENAI_API_KEY
    text = _parse_query('text')
    translate_text = _translate_text(target='en', text=text)
    return translate_text

@app.route('/summarization', endpoint='summarization', methods=["GET"])
@_decorator_of_auth_verification
def summarization():
    print('summarization',OPENAI_API_KEY)
    try:
        #return 'a'
        openai.api_key = OPENAI_API_KEY
        openai.api_key = 'sk-p7a2m58uX8PwXkX3vFA7eFJal6sPOfFtx2dGb1PD'
        print('openai.api_key',openai.api_key)
        input_text = _parse_query('text')
        engine = _parse_query('engine')
        max_tokens = _parse_query('max_tokens')
        temperature = _parse_query('temperature')
        print('here')
        print('engine',engine)
        print('max_tokens',max_tokens)
        print('temperature',temperature)


        translate_text = _translate_text(target='en', text=input_text)
        ##return translate_text
        print('here2',translate_text)

        ## Summarization
        prompt = "A neutron star is the collapsed core of a massive supergiant star, which had a total mass of between 10 and 25 solar masses, possibly more if the star was especially metal-rich.[1] Neutron stars are the smallest and densest stellar objects, excluding black holes and hypothetical white holes, quark stars, and strange stars.[2] Neutron stars have a radius on the order of 10 kilometres (6.2 mi) and a mass of about 1.4 solar masses.[3] They result from the supernova explosion of a massive star, combined with gravitational collapse, that compresses the core past white dwarf star density to that of atomic nuclei.\n\ntl;dr:"
        prompt = ("{text}\n\ntl;dr:"
                    .format(text=translate_text))
        print('here4',prompt)
        
        response = openai.Completion.create(
            engine=engine,
            prompt=prompt,
            temperature=float(temperature),
            max_tokens=int(max_tokens),
            top_p=1.0,
            frequency_penalty=0.0,
            presence_penalty=0.0,
            stop=["\"\"\""]
            )

        print('done')
        export_text = _translate_text(target='ja', text=response["choices"][0]['text'])
        return export_text
    except Exception as e:
        print(e)
        return 'Internal server error 500:Error on a backend program.'



@app.route('/answer', endpoint='answer', methods=["GET"])
@_decorator_of_auth_verification
def answer():
    print('answer',OPENAI_API_KEY)
    try:
        #return 'a'
        openai.api_key = OPENAI_API_KEY
        input_text = _parse_query('text')
        engine = _parse_query('engine')
        max_tokens = _parse_query('max_tokens')
        temperature = _parse_query('temperature')
        print('here')
        print('engine',engine)
        print('max_tokens',max_tokens)
        print('temperature',temperature)


        #translate_text = _translate_text(target='en', text=input_text)
        ##return translate_text
 
        translate_text = input_text
        

        ## 俳句が作れるか
        dics = {
            'すみれ草':'山路来て 何やらゆかし すみれ草',
            '梅':'梅が香に のっと日の出る 山路かな',
            '春の海':'春の海 ひねもすのたり のたりかな',
            '雪解け':'雪とけて 村いっぱいの 子どもかな',
            '春の昼':'白雲と 旅する時間 春の昼',
            '花屑':'花屑を 踏めば小さな 山河あり',
            '藤':'藤の滝 くぐれば開く 明日の夢',
            '花筏':'散り際を 風は残さず 花筏',
            '春':'カラカラと 鋤簾呼び込む 春の水',
            }

        #算数ができるか
        dics = {
            '10+20':'30',
            '100*10':'1000',
            }

        ###改行ができるか
        dics = {
            'すみれくさ':"""やまじきて
            なにやらゆかし
            すみれくさ""",
            'うめ':"""うめがかに
            のっとひのでる
            やまじかな""",
            }
        ### 病気について
        dics = {
            'すみれくさ':"""やまじきて
            なにやらゆかし
            すみれくさ""",
            'うめ':"""うめがかに
            のっとひのでる
            やまじかな""",
            }

        ## 基本情報処理
        dics = {
            'アウトソーシング':'自社の業務の一部又は業務のすべてを外部へ委託すること。専門的な知識・技能が必要となる業務を、その業務を得意とする業者へ外注することで人材育成や設備投資のコストが低減されるメリットがある。',
            'アジャイル':'俊敏な」「すばやい」という意味の英単語で、ソフトウェアを迅速かつ適応的にソフトウェア開発を行う軽量な開発手法の総称。 開発プロジェクトを短期間に区切り、その期間内に「要件定義」～「テスト」「運用」までの開発工程を一通り行い、一部分の機能を完成させるという作業を繰り返すことで段階的にシステムを開発していくモデル。',
            'アフィリエイト':'企業の広告を個人(企業)の所有するホームページに掲載し、そのリンクをたどって企業の商品やサービスが売れた場合に、広告を載せているホームページの主に報酬を支払うという仕組み。',
            'アローダイアグラム':'プロジェクトの各作業間の関連性や順序関係を視覚的に表現する図。作業の前後関係を分析することで時間的に余裕のない一連の作業(クリティカルパス)を洗い出すことができるためプロジェクトのスケジュール管理に使用される。PERT図とも呼ばれる。'
            }
        ## 日経キーワード
        dics = {
            '地球観測衛星':'地球の陸や海、大気などを宇宙から観測し、災害や地球温暖化の対策などに役立てる人工衛星。天気予報に生かす気象衛星や軍事目的の偵察衛星などもある。 多くの衛星は主に高度約400～1000キロメートルから、一定期間をかけて地球を観測している。',
            'コモンズの悲劇':'共有の資源を巡って、個人の利益を追求しすぎるあまり、全体としては不利益を被ってしまうことへの警鐘。米生態学者のギャレット・ハーディン氏が1968年に唱えた。共有地（コモンズ）の悲劇ともいう。 ',
            'ライフサイクルアセスメント':'製品やサービスが生まれてから廃棄されるまでのライフサイクル（一生）を通じた環境負荷を評価する取り組み。LCAともいう。ライフサイクルは自動車のような工業製品であれば原料となる鉄などの資源採掘から製造、使用、メンテナンス、リサイクル、廃棄までを指す。',
            }

        ## 与えた物の中に

        dics = {
            'Pythonはどんな言語ですか？':'Python（パイソン）はインタープリタ型の高水準汎用プログラミング言語である。グイド・ヴァン・ロッサムにより創り出され、1991年に最初にリリースされたPythonの設計哲学は、有意なホワイトスペース(オフサイドルール)の顕著な使用によってコードの可読性を重視している。その言語構成とオブジェクト指向のアプローチは、プログラマが小規模なプロジェクトから大規模なプロジェクトまで、明確で論理的なコードを書くのを支援することを目的としている。Pythonは動的に型付けされていて、ガベージコレクションされている。構造化（特に手続き型）、オブジェクト指向、関数型プログラミングを含む複数のプログラミングパラダイムをサポートしている。Pythonは、その包括的な標準ライブラリのため、しばしば「バッテリーを含む」言語と表現される[4]。Pythonは1980年代後半にABC言語の後継として考案された。2000年にリリースされたPython 2.0では、リスト内包表記や参照カウントによるガベージコレクションシステムなどの機能が導入された。2008年にリリースされたPython 3.0は、完全な下位互換性を持たない言語の大規模な改訂であり、Python 2のコードの多くはPython 3では変更なしには動作しない。Python 2言語は2020年に正式に廃止され（当初は2015年予定）、"Python 2.7.18はPython 2.7の最後のリリースであり、したがってPython 2の最後のリリースである "[5]とされている。これ以上のセキュリティパッチやその他の改善はリリースされない[6]。Python 2が終了したことで、サポートされるのはPython 3.5.x以降[7]のみとなる。Pythonのインタプリタは多くのOSに対応している。プログラマーのグローバルコミュニティは、無料のオープンソース [8] リファレンス実装であるCPythonを開発および保守している 。非営利団体であるPythonソフトウェア財団は、PythonとCPythonの開発のためのリソースを管理・指導している。',
            'Scalaはどんな言語ですか？':'Scala（スカラ、SKAH-lah[3]）はオブジェクト指向言語と関数型言語の特徴を統合したマルチパラダイムのプログラミング言語である。名前の「Scala」は英語の「scalable language」に由来するものである。',
            'Rubyはどんな言語ですか？':'Ruby（ルビー）は、まつもとゆきひろ（通称: Matz）により開発されたオブジェクト指向スクリプト言語（スクリプト言語とはプログラミング言語の一分類）。日本で開発されたプログラミング言語としては初めて国際電気標準会議（IEC）で国際規格に認証された事例となった[3]。'
            }

        ## Answer
        prompt = 'プログラミング言語について詳しく知りたいです。\n'
        for q,a in dics.items():
            prompt += "Q: {question}\nA: {answer}\n###\n".format(question=q, answer=a) 
        prompt += "Q: {text}\nA:".format(text=translate_text)
        #prompt = ("I am a highly intelligent question answering bot. If you ask me a question that is rooted in truth, I will give you the answer. If you ask me a question that is nonsense, trickery, or has no clear answer, I will respond with \"Unknown\".\n\nQ: What is human life expectancy in the United States?\nA: Human life expectancy in the United States is 78 years.\n\nQ: Who was president of the United States in 1955?\nA: Dwight D. Eisenhower was president of the United States in 1955.\n\nQ: Which party did he belong to?\nA: He belonged to the Republican Party.\n\nQ: What is the square root of banana?\nA: Unknown\n\nQ: How does a telescope work?\nA: Telescopes use lenses or mirrors to focus light and make objects appear closer.\n\nQ: Where were the 1992 Olympics held?\nA: The 1992 Olympics were held in Barcelona, Spain.\n\nQ: How many squigs are in a bonk?\nA: Unknown\n\nQ: {text}\nA:"
        #        .format(text=translate_text))
        print('here4',prompt)
        
        response = openai.Completion.create(
            engine=engine,
            prompt=prompt,
            temperature=float(temperature),
            max_tokens=int(max_tokens),
            top_p=1.0,
            frequency_penalty=0.0,
            presence_penalty=0.0,
            stop=["###"]
            )
        #export_text = _translate_text(target='ja', text=response["choices"][0]['text'])
        export_text = response["choices"][0]['text']
        return export_text
    except Exception as e:
        print(e)
        return 'Internal server error 500:Error on a backend program.'




@app.route('/chat', endpoint='chat', methods=["GET"])
@_decorator_of_auth_verification
def chat():
    print('chat',OPENAI_API_KEY)
    try:
        #return 'a'
        openai.api_key = OPENAI_API_KEY
        input_text = _parse_query('text')
        engine = _parse_query('engine')
        max_tokens = _parse_query('max_tokens')
        temperature = _parse_query('temperature')
        print('here')
        print('engine',engine)
        print('max_tokens',max_tokens)
        print('temperature',temperature)


        translate_text = _translate_text(target='en', text=input_text)
        ##return translate_text
        print('here2',translate_text)
        

        prompt = ("You: What have you been up to?\nFriend: Watching old movies.\nYou: {text}\nFriend:"
                .format(text=translate_text))

        response = openai.Completion.create(
            engine=engine,
            prompt=prompt,
            temperature=float(temperature),
            max_tokens=int(max_tokens),
            top_p=1.0,
            frequency_penalty=0.5,
            presence_penalty=0.0,
            stop=["You:"]
        )       

        print('done')
        export_text = _translate_text(target='ja', text=response["choices"][0]['text'])
        return export_text
    except Exception as e:
        print(e)
        return 'Internal server error 500:Error on a backend program.'



if __name__ == "__main__":
    #pass
    app.run(host='127.0.0.1',port='5000',debug=True)
